Index: ipsec.c
===================================================================
RCS file: /cvs/src/sbin/isakmpd/ipsec.c,v
retrieving revision 1.127
diff -u -r1.127 ipsec.c
--- ipsec.c	24 Nov 2006 13:52:14 -0000	1.127
+++ ipsec.c	17 Aug 2007 14:31:04 -0000
@@ -1711,6 +1711,13 @@
 			 * disappear too.
 			 */
 			msg->transport->vtbl->get_dst(msg->transport, &dst);
+			if(dst->sa_family == AF_INET)
+			{
+				struct sockaddr_in *dst_in = (struct sockaddr_in *)dst;
+				LOG_DBG((LOG_SA, 30, "XXX: looking for a matching peer to %s:%u",
+					inet_ntoa(dst_in->sin_addr),
+					ntohs(dst_in->sin_port)));
+			}
 			while ((sa = sa_lookup_by_peer(dst, SA_LEN(dst), 0)) != 0) {
 				/*
 				 * Don't delete the current SA -- we received
@@ -1726,6 +1733,17 @@
 					reenter = 1;
 					continue;
 				}
+
+				struct sockaddr *dstx;
+				sa->transport->vtbl->get_dst(sa->transport, &dstx);
+				if(dstx->sa_family == AF_INET)
+				{
+					struct sockaddr_in *dst_in = (struct sockaddr_in *)dstx;
+					LOG_DBG((LOG_SA, 30, "XXX: found matching peer %s:%u",
+						inet_ntoa(dst_in->sin_addr),
+						ntohs(dst_in->sin_port)));
+				}
+
 				LOG_DBG((LOG_SA, 30,
 				    "ipsec_handle_leftover_payload: "
 				    "INITIAL-CONTACT made us delete SA %p",
Index: sa.c
===================================================================
RCS file: /cvs/src/sbin/isakmpd/sa.c,v
retrieving revision 1.110
diff -u -r1.110 sa.c
--- sa.c	24 Nov 2006 13:52:14 -0000	1.110
+++ sa.c	17 Aug 2007 14:31:04 -0000
@@ -199,7 +199,18 @@
 		return 0;
 
 	sa->transport->vtbl->get_dst(sa->transport, &dst);
-	return (net_addrcmp(dst, addr->addr) == 0);
+	if (net_addrcmp(dst, addr->addr) != 0)
+		return 0;
+
+	/* same family, length and address, check port if inet/inet6 */
+	switch (dst->sa_family) {
+	case AF_INET:
+		return ((struct sockaddr_in *)dst)->sin_port == ((struct sockaddr_in *)addr->addr)->sin_port;
+	case AF_INET6:
+		return ((struct sockaddr_in6 *)dst)->sin6_port == ((struct sockaddr_in6 *)addr->addr)->sin6_port;
+	}
+
+	return 1;
 }
 
 struct dst_isakmpspi_arg {
